//*****************************************************//
//                                                     //
//           Programme Alimentation variable           //
//               avec carte ARDUINO NANO               //
//       et un convertisseur digital - analogique      //
//                                                     //
//               UAICF Nevers-Vauzelles                //
//            http://modelisme58.free.fr               //
//                                                     //
//                    Version 1.0                      //
//                     Aout 2020                       //
//                                                     //
//*****************************************************//

//*** Bibliothèque à installer
#include <EEPROM.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <Bounce2.h>

//*** Fichiers liés
#include "a_modifier.h"
#include "configuration.h"
#include "fonctions.h"
#include "portserie.h"


//*** SETUP *******************************************************************************
void setup()
{
  delay(1000);
  Wire.begin();
  CalculDAC(0);
  Serial.begin(9600);
  Configuration();
  Serial.println(F("UAICF Nevers-Vauzelles - http://modelisme58.free.fr"));
  Serial.println(F("Alimentation Analogique variable - Version 1.0"));

  LCD.init();       // Initialisation et Affichage Ecran LCD
  LCD.backlight();
  LCD.clear();
  LCD.noCursor();
  LCD.noBlink();
  LCD.setCursor(0, 0);
  LCD.print("Gestion Analogic");
  LCD.setCursor(2, 1);
  LCD.print("Manu ou Auto");

  Serial.println(F("\nSaisir $H pour visualiser la configuration"));
  Serial.println(F("Saisir $P pour visualiser les paramètres modifiables avec les potentiometres"));

  AffichageConfiguration();
  AffichageParametres();

  delay (2000);
  Serial.println(F("***************************************************"));
}


//*** Programme PRINCIPAL *****************************************************************
void loop()
{
  SelectBt_Mode.update();
  SelectBt_Config.update();
  SelectBt_Urgence.update();
  Mode = SelectBt_Mode.read();
  Config = SelectBt_Config.read();
  ModeUrgence = SelectBt_Urgence.read();

  if (ModeUrgence != ModeUrgenceOld)
  {
    ModeUrgenceOld = ModeUrgence;
    if (ModeUrgence == 0)
    {
      switch (ArretUrgence)
      {
        case false:
          CalculDAC(0);
          VitesseOld = 0;
          ArretUrgence = true;
          LCD.clear();
          LCD.blink();
          LCD.print("Arret URGENCE !");
          Compteur = 0;
          Cycle = 0;
          CycleConfig = 0;
          Config = 0;
          ConfigOld = 0;
          SelectBt_Urgence.interval(2000);
          break;

        case true:
          ArretUrgence = false;
          SelectBt_Urgence.interval(500);
          LCD.clear();
          LCD.noBlink();
          CycleNouveau = 0;
          if (Mode == 0)
          {
            LCD.print(" Commande Manu.");
            LCD.setCursor(0, 1);
            LCD.print(" Vitesse = ");
            LCD.setCursor(11, 1);
            Vitesse = analogRead(PotVitesse);
            Vitesse = map(Vitesse, 0, 1023, VitMini, 1023);
            byte Vit = map(Vitesse, 0, 1023, 0, 100);
            LCD.print(Vit);  LCD.print(" % ");
            Cycle = 5;
          }
          break;
      }
    }
  }

  if (!ArretUrgence)
  {
    Programme();
  }
}
