//***********************************************************************
void AffichageConfiguration()
{
  Serial.print(F("\nBorne Pot. Tempo. Mini = ")); Serial.print(TemporisationMini); Serial.println(F(" secondes --> Saisir $txx avec xx temps en secondes"));
  Serial.print(F("Borne Pot. Tempo. Maxi = ")); Serial.print(TemporisationMaxi); Serial.println(F(" secondes --> Saisir $Txx avec xx temps en secondes"));
  Serial.print(F("Borne Pot. Vitesse Mini = ")); Serial.print(VitMini / 10); Serial.println(F(" --> Saisir $Vxx avec xx entre 0 et 91"));
  Serial.print(F("Borne Pot. Acceleration/Freinage Maxi = ")); Serial.print(AccDeccMaxi); Serial.println(F(" millisecondes --> Saisir $Axx avec xx temps en millisecondes"));
}


//***********************************************************************
void AffichageParametres()
{
  int AccDecc = analogRead(PotAcceDecc);
  AccDecc = map(AccDecc, 0, 1023, AccDeccMini, AccDeccMaxi);
  Serial.print(F("\nPas Acceleration/Freinage = ")); Serial.print(AccDecc); Serial.println(F(" millisecondes"));

  TempoMini = analogRead(PotTempoMini);
  TempoMini = map(TempoMini, 0, 1023, TemporisationMini, TemporisationMaxi);
  Serial.print(F("Temporisation Mini = ")); Serial.print(TempoMini); Serial.println(F(" secondes"));

  TempoMaxi = analogRead(PotTempoMaxi);
  TempoMaxi = map(TempoMaxi, 0, 1023, TemporisationMini, TemporisationMaxi);
  if (TempoMaxi < TempoMini) TempoMaxi = TempoMini + 5;
  Serial.print(F("Temporisation Maxi = ")); Serial.print(TempoMaxi); Serial.println(F(" secondes"));

  VitesseMini = analogRead(PotVitesseMini);
  VitesseMini = map(VitesseMini, 0, 1023, VitMini, 1023);
  VitesseMini = map(VitesseMini, 0, 1023, 0, 100);
  Serial.print(F("Vitesse Mini = ")); Serial.println(VitesseMini); //Serial.println("%");

  VitesseMaxi = analogRead(PotVitesseMaxi);
  VitesseMaxi = map(VitesseMaxi, 0, 1023, VitMini, 1023);
  VitesseMaxi = map(VitesseMaxi, 0, 1023, 0, 100);
  Serial.print(F("Vitesse Maxi = ")); Serial.println(VitesseMaxi); //Serial.println("%");

  Vitesse = analogRead(PotVitesse);
  Vitesse = map(Vitesse, 0, 1023, VitMini, 1023);
  Vitesse = map(Vitesse, 0, 1023, 0, 100);
  Serial.print(F("Vitesse Manuelle = ")); Serial.println(Vitesse); //Serial.println("%");
}


//***********************************************************************
void Configuration()
{
  pinMode(Bt_Mode, INPUT_PULLUP);
  pinMode(Bt_Config, INPUT_PULLUP);
  pinMode(Bt_Urgence, INPUT_PULLUP);

  SelectBt_Mode.attach(Bt_Mode);
  SelectBt_Config.attach(Bt_Config);
  SelectBt_Urgence.attach(Bt_Urgence);

  SelectBt_Mode.interval(500);
  SelectBt_Config.interval(500);
  SelectBt_Urgence.interval(500);

  TemporisationMini = EEPROM.get(EepromTemporisationMini, TemporisationMini);
  if (TemporisationMini < PasDefaut || TemporisationMini > 100)
  {
    TemporisationMini = PasDefaut;
    EEPROM.put(EepromTemporisationMini, TemporisationMini);
  }

  TemporisationMaxi = EEPROM.get(EepromTemporisationMaxi, TemporisationMaxi);
  if (TemporisationMaxi < TemporisationMini || TemporisationMini > 600)
  {
    TemporisationMaxi = TemporisationMini + 240;
    EEPROM.put(EepromTemporisationMaxi, TemporisationMaxi);
  }

  VitMini = EEPROM.get(EepromVitMin, VitMini);
  if (VitMini < 0 || VitMini > 300)
  {
    VitMini = VitMiniDefaut;
    EEPROM.put(EepromVitMin, VitMini);
  }

  AccDeccMaxi = EEPROM.get(EepromAccDeccMaxi, AccDeccMaxi);
  if (AccDeccMaxi < 1 || AccDeccMaxi > 2000)
  {
    AccDeccMaxi = AccDeccMaxiDefaut;
    EEPROM.put(EepromAccDeccMaxi, AccDeccMaxi);
  }
}


//***********************************************************************
void CalculDAC(int v)
{
  Buffer[0] = v >> 2;                  // MSB 11-4 shift right 4 places
  Buffer[1] = ((v << 2) & 15) << 4;    // LSB 3-0 shift left 4 places

  Wire.beginTransmission(MCP4725_ADDR);
  Wire.write(64);
  Wire.write(Buffer[0]);  // 8 MSB
  Wire.write(Buffer[1]);  // 4 LSB
  Wire.endTransmission();
}


//***********************************************************************
void VitesseManu()
{
  Vitesse = analogRead(PotVitesse);
  Vitesse = map(Vitesse, 0, 1023, VitMini, 1023);
  if (VitesseOld != Vitesse && Cycle == 5)
  {
    if (millis() > Compteur)
    {
      int AccDecc = analogRead(PotAcceDecc);
      AccDecc = map(AccDecc, 0, 1023, AccDeccMini, AccDeccMaxi);

      if (Vitesse > VitesseOld)
      {
        VitesseOld++;
        CalculDAC(VitesseOld);
        Compteur = millis() + AccDecc;

        LCD.setCursor(11, 1);
        LCD.print("    ");
        LCD.setCursor(11, 1);
        byte Vit = map(VitesseOld, 0, 1023, 0, 100);
        LCD.print(Vit);  LCD.print("   ");
      }

      if (Vitesse < VitesseOld)
      {
        VitesseOld--;
        CalculDAC(VitesseOld);
        Compteur = millis() + AccDecc;

        LCD.setCursor(11, 1);
        LCD.print("    ");
        LCD.setCursor(11, 1);
        byte Vit = map(VitesseOld, 0, 1023, 0, 100);
        LCD.print(Vit);  LCD.print("   ");
      }
      LCD.blink();
    }

    if (Vitesse == VitesseOld)
    {
      Cycle = 0;
      LCD.noBlink();
    }
  }

  if (Cycle != 5)
  {
    int VitesseMoins = Vitesse * EcartVitesseManuInf;
    int VitessePlus = Vitesse * EcartVitesseManuSup;

    if (VitesseOld > VitessePlus || VitesseOld < VitesseMoins)
    {
      CalculDAC(Vitesse);
      VitesseOld = Vitesse;
      LCD.setCursor(11, 1);
      LCD.print("    ");
      LCD.setCursor(11, 1);
      byte Vit = map(Vitesse, 0, 1023, 0, 100);
      LCD.print(Vit);  LCD.print("   ");
      Cycle = 5;
    }
  }
}


//***********************************************************************
void VitesseAuto()
{
  switch (CycleConfig)
  {
    case 0:
      {
        if (millis() > Compteur && Cycle == 1)
        {
          int AccDecc = analogRead(PotAcceDecc);
          AccDecc = map(AccDecc, 0, 1023, AccDeccMini, AccDeccMaxi);

          if (Vitesse > VitesseOld)
          {
            VitesseOld++;
            CalculDAC(VitesseOld);
            Compteur = millis() + AccDecc;
          }

          if (Vitesse < VitesseOld)
          {
            VitesseOld--;
            CalculDAC(VitesseOld);
            Compteur = millis() + AccDecc;
          }

          if (!CycleNouveau)
          {
            byte VitMax = map(Vitesse, 0, 1023, 0, 100);
            LCD.clear();
            LCD.setCursor(8, 0);
            LCD.print("Cmd="); LCD.print(VitMax); LCD.print("     ");
            LCD.setCursor(0, 1);
            LCD.print("----------------");
            LCD.setCursor(15, 1);
            CycleNouveau = 1;
          }

          byte Vit = map(VitesseOld, 0, 1023, 0, 100);
          LCD.noBlink();
          LCD.setCursor(0, 0);
          LCD.print("V="); LCD.print(Vit); LCD.print("    ");

          if (Vitesse == VitesseOld)
          {
            Cycle = 2;
            //*** Calcul de la temporisation entre 2 consignes
            TempoMini = analogRead(PotTempoMini);
            TempoMaxi = analogRead(PotTempoMaxi);

            if (TempoMini > TempoMaxi)
            {
              TempoMini = TempoMaxi * EcartVitesseInf;
            }

            if (TempoMini < 0)
            {
              TempoMini = 0;
              TempoMaxi = 100;
            }

            Temporisation = random(TempoMini, TempoMaxi);
            Temporisation = map(Temporisation, 0, 1023, TemporisationMini, TemporisationMaxi);
            Temporisation = Temporisation * 1000;
            Compteur = millis() + Temporisation;
            Pas = PasDefaut;
            Compteur2 = millis() + Temporisation / Pas;
            LCD.blink();
            int TpsRestant = Temporisation / 1000;
            LCD.setCursor(8, 0);
            LCD.print("      ");
            byte Position;
            if (TpsRestant < 10) Position = 10;
            if (TpsRestant > 9 && TpsRestant < 100) Position = 9;
            if (TpsRestant > 99) Position = 8;
            LCD.setCursor(Position, 0);
            LCD.print(TpsRestant);
            LCD.print(" sec.");
          }
        }

        if (millis() > Compteur2 && Cycle == 2)
        {
          int TpsRestant = Temporisation / 1000;
          TpsRestant = TpsRestant / PasDefaut;
          Pas--;
          TpsRestant = TpsRestant * Pas;
          LCD.setCursor(8, 0);
          LCD.print("      ");
          byte Position;
          if (TpsRestant < 10) Position = 10;
          if (TpsRestant > 9 && TpsRestant < 100) Position = 9;
          if (TpsRestant > 99) Position = 8;
          LCD.setCursor(Position, 0);
          LCD.print(TpsRestant);
          LCD.print(" sec.");

          LCD.setCursor(Pas, 1);
          LCD.print(" ");
          LCD.setCursor(Pas, 1);
          Compteur2 = millis() + Temporisation / 16;
          if (Pas < 1)
          {
            Cycle = 0;
            Compteur = 0;
            CycleNouveau = 0;
          }
        }

        if (millis() > Compteur && Cycle == 0)
        {
          Cycle = 0;
          boolean VitesseOk = false;
          while (!VitesseOk)
          {
            //*** Calcul de la nouvelle consigne de vitesse
            VitesseMini = analogRead(PotVitesseMini);
            VitesseMaxi = analogRead(PotVitesseMaxi);

            if (VitesseMini > VitesseMaxi * EcartVitesseInf)
            {
              VitesseMini = VitesseMaxi * EcartVitesseInf;
              VitesseMini = VitesseMini - 100;
            }

            if (VitesseMini < 0)
            {
              VitesseMini = 0;
            }

            if (VitesseMaxi < 50)
            {
              VitesseMaxi = 100;
            }

            Vitesse = random(VitesseMini, VitesseMaxi);
            Vitesse = map(Vitesse, 0, 1023, VitMini, 1023);

            int VitesseMoins = Vitesse * EcartVitesseInf;
            int VitessePlus = Vitesse * EcartVitesseSup;
            if (VitesseOld > VitessePlus || VitesseOld < VitesseMoins)
            {
              VitesseOk = true;
              Compteur = millis() + 500;
              Cycle++;
            }
          }
        }
      }
      break;

    case 1:
      {
        VitesseMini = analogRead(PotVitesseMini);
        VitesseMaxi = analogRead(PotVitesseMaxi);
        VitesseMini = map(VitesseMini, 0, 1023, VitMini, 1023);
        VitesseMini = map(VitesseMini, 0, 1023, 0, 100);
        VitesseMaxi = map(VitesseMaxi, 0, 1023, VitMini, 1023);
        VitesseMaxi = map(VitesseMaxi, 0, 1023, 0, 100);

        if (VitesseMini != VitesseMiniOld)
        {
          LCD.setCursor(12, 0);
          LCD.print(VitesseMini); LCD.print("%    ");
          VitesseMiniOld = VitesseMini;
        }

        if (VitesseMaxi > VitesseMaxiOld + 1 || VitesseMaxi < VitesseMaxiOld - 1)
        {
          LCD.setCursor(12, 1);
          LCD.print(VitesseMaxi); LCD.print("      ");
          VitesseMaxiOld = VitesseMaxi;
        }
        break;

      case 2:
        {
          TempoMini = analogRead(PotTempoMini);
          TempoMaxi = analogRead(PotTempoMaxi);

          TempoMini = map(TempoMini, 0, 1023, TemporisationMini, TemporisationMaxi);
          TempoMaxi = map(TempoMaxi, 0, 1023, TemporisationMini, TemporisationMaxi);
          if (TempoMaxi < TempoMini) TempoMaxi = TempoMini + 5;

          if (TempoMini != TempoMiniOld)
          {
            LCD.setCursor(11, 0);
            LCD.print(TempoMini); LCD.print("s    ");
            TempoMiniOld = TempoMini;
          }

          if (TempoMaxi != TempoMaxiOld)
          {
            LCD.setCursor(11, 1);
            LCD.print(TempoMaxi); LCD.print("s    ");
            TempoMaxiOld = TempoMaxi;
          }
          break;
        }

      case 3:
        {
          int AccDecc = analogRead(PotAcceDecc);
          AccDecc = map(AccDecc, 0, 1023, 0, 100);
          if (AccDecc != AccDeccOld)
          {
            LCD.setCursor(12, 1);
            LCD.print(AccDecc); LCD.print("%   ");
            AccDeccOld = AccDecc;
          }
          break;
        }
      }
  }
}

void Programme()
{
  switch (CycleConfig)
  {
    case 1:
      VitesseMini = analogRead(PotVitesseMini);
      VitesseMaxi = analogRead(PotVitesseMaxi);
      VitesseMini = map(VitesseMini, 0, 1023, VitMini, 1023);
      VitesseMini = map(VitesseMini, 0, 1023, 0, 100);
      VitesseMaxi = map(VitesseMaxi, 0, 1023, VitMini, 1023);
      VitesseMaxi = map(VitesseMaxi, 0, 1023, 0, 100);

      if (VitesseMini != VitesseMiniOld + 1 || VitesseMini < VitesseMiniOld - 1)
      {
        LCD.setCursor(0, 0);
        LCD.print("Vit. Mini = "); LCD.print(VitesseMini); LCD.print("     ");
        VitesseMiniOld = VitesseMini;
      }

      if (VitesseMaxi != VitesseMaxiOld + 1 || VitesseMaxi < VitesseMaxiOld - 1)
      {
        LCD.setCursor(0, 1);
        LCD.print("Vit. Maxi = "); LCD.print(VitesseMaxi); LCD.print("     ");
        VitesseMaxiOld = VitesseMaxi;
      }
      break;

    case 2:
      TempoMini = analogRead(PotTempoMini);
      TempoMaxi = analogRead(PotTempoMaxi);
      if (TempoMaxi < TempoMini) TempoMaxi = TempoMini + 5;
      TempoMini = map(TempoMini, 0, 1023, TemporisationMini, TemporisationMaxi);
      TempoMaxi = map(TempoMaxi, 0, 1023, TemporisationMini, TemporisationMaxi);

      if (TempoMini > TempoMiniOld + 1 || TempoMini < TempoMiniOld - 1)
      {
        LCD.setCursor(0, 0);
        LCD.print("Tps Mini = "); LCD.print(TempoMini); LCD.print("s    ");
        TempoMiniOld = TempoMini;
      }

      if (TempoMaxi > TempoMaxiOld + 1 || TempoMaxi < TempoMaxiOld - 1)
      {
        LCD.setCursor(0, 1);
        LCD.print("Tps Maxi = "); LCD.print(TempoMaxi); LCD.print("s    ");
        TempoMaxiOld = TempoMaxi;
      }
      break;

    case 3:
      {
        int AccDecc = analogRead(PotAcceDecc);
        AccDecc = map(AccDecc, 0, 1023, 0, 100);
        if (AccDecc > AccDeccOld + 1 || AccDecc < AccDeccOld - 1)
        {
          LCD.setCursor(12, 1);
          LCD.print(AccDecc); LCD.print("%   ");
          AccDeccOld = AccDecc;
        }
      }
      break;
  }

  if (Config != ConfigOld && Mode == 1)
  {
    ConfigOld = Config;
    if (Config == 0)
    {
      CycleNouveau = 0;
      CycleConfig++;
      delay (100);
      LCD.noBlink();

      switch (CycleConfig)
      {
        case 1:
          VitesseMini = analogRead(PotVitesseMini);
          VitesseMaxi = analogRead(PotVitesseMaxi);
          VitesseMini = map(VitesseMini, 0, 1023, VitMini, 1023);
          VitesseMini = map(VitesseMini, 0, 1023, 0, 100);
          VitesseMaxi = map(VitesseMaxi, 0, 1023, VitMini, 1023);
          VitesseMaxi = map(VitesseMaxi, 0, 1023, 0, 100);

          if (VitesseMini != VitesseMiniOld + 1 || VitesseMini < VitesseMiniOld - 1)
          {
            LCD.setCursor(0, 0);
            LCD.print("Vit. Mini = "); LCD.print(VitesseMini); LCD.print("     ");
            VitesseMiniOld = VitesseMini;
          }

          if (VitesseMaxi != VitesseMaxiOld + 1 || VitesseMaxi < VitesseMaxiOld - 1)
          {
            LCD.setCursor(0, 1);
            LCD.print("Vit. Maxi = "); LCD.print(VitesseMaxi); LCD.print("     ");
            VitesseMaxiOld = VitesseMaxi;
          }
          break;

        case 2:
          TempoMini = analogRead(PotTempoMini);
          TempoMaxi = analogRead(PotTempoMaxi);
          if (TempoMaxi < TempoMini) TempoMaxi = TempoMini + 5;

          TempoMini = map(TempoMini, 0, 1023, TemporisationMini, TemporisationMaxi);
          TempoMaxi = map(TempoMaxi, 0, 1023, TemporisationMini, TemporisationMaxi);

          if (TempoMini > TempoMiniOld + 1 || TempoMini < TempoMiniOld - 1)
          {
            LCD.setCursor(0, 0);
            LCD.print("Tps Mini = "); LCD.print(TempoMini); LCD.print("s    ");
            TempoMiniOld = TempoMini;
          }

          if (TempoMaxi > TempoMaxiOld + 1 || TempoMaxi < TempoMaxiOld - 1)
          {
            LCD.setCursor(0, 1);
            LCD.print("Tps Maxi = "); LCD.print(TempoMaxi); LCD.print("s    ");
            TempoMaxiOld = TempoMaxi;
          }
          break;

        case 3:
          {
            AccDeccOld = 1023;
            LCD.clear();
            int AccDecc = analogRead(PotAcceDecc);
            AccDecc = map(AccDecc, 0, 1023, 0, 100);
            if (AccDecc > AccDeccOld + 1 || AccDecc < AccDeccOld - 1)
            {
              LCD.print("Acceleration &");
              LCD.setCursor(0, 1);
              LCD.print("  Freinage");
              LCD.setCursor(12, 1);
              LCD.print(AccDecc); LCD.print("%   ");
              AccDeccOld = AccDecc;
            }
          }
          break;

        default:
          CycleConfig = 0;
          Config = 0;
          ConfigOld = 0;
          Compteur = 0;
          Cycle = 0;
          byte Vit = map(VitesseOld, 0, 1023, 0, 100);
          LCD.clear();
          LCD.noBlink();
          LCD.setCursor(0, 0);
          LCD.print("V="); LCD.print(Vit); LCD.print("      ");
          break;
      }
    }
  }

  if (Config)
  {
    if (Mode != ModeOld)
    {
      ModeOld = Mode;
      if (Mode == 0)
      {
        LCD.clear();
        LCD.blink();
        LCD.print(" Commande Manu.");
        LCD.setCursor(0, 1);
        LCD.print(" Vitesse = ");
        LCD.setCursor(11, 1);
        Vitesse = analogRead(PotVitesse);
        Vitesse = map(Vitesse, 0, 1023, VitMini, 1023);
        byte Vit = map(Vitesse, 0, 1023, 0, 100);
        LCD.print(Vit);  LCD.print("   ");
        Cycle = 5;
        Compteur = 0;
      }

      if (Mode == 1)
      {
        Compteur = 0;
        Cycle = 0;
        CycleConfig = 0;
        Config = 0;
        ConfigOld = 0;
        byte Vit = map(VitesseOld, 0, 1023, 0, 100);
        LCD.clear();
        LCD.noBlink();
        LCD.setCursor(0, 0);
        LCD.print("V="); LCD.print(Vit); LCD.print("      ");
      }
    }

    switch (Mode)
    {
      case 0:
        {
          VitesseManu();
          break;
        }

      case 1:
        {
          if (!CycleConfig) VitesseAuto();
          break;
        }
    }
  }
}
