//*** Gestion des informations reçues sur le port série ***

long EntreeCaractere;
byte SelectionChar;
byte NbreCaractere;
boolean ValideConsigne;
int c;
char inChar;

void ScanPortSeries()
{
  c = (int)inChar;
  NbreCaractere++;

  if (c > 47 && c < 58)
  {
    EntreeCaractere =  EntreeCaractere * 10 + c - 48;
  }

  if (c == '$' && NbreCaractere == 1)
  {
    ValideConsigne = true;
  }

  if (NbreCaractere == 2)
  {
    switch (c)
    {
      case 'H':
        SelectionChar = 1;
        break;

      case 'h':
        SelectionChar = 1;
        break;

      case 'P':
        SelectionChar = 2;
        break;

      case 'p':
        SelectionChar = 2;
        break;

      case 'V':
        SelectionChar = 3;
        break;

      case 'v':
        SelectionChar = 3;
        break;

      case 'A':
        SelectionChar = 4;
        break;

      case 'a':
        SelectionChar = 4;
        break;

      case 't':
        SelectionChar = 5;
        break;

      case 'T':
        SelectionChar = 6;
        break;
    }
  }

  if (inChar == '\n' || inChar == '\r')
  {
    if (ValideConsigne == true)
    {
      switch (SelectionChar)
      {
        case 1:  //*** Affichage des constantes ***
          AffichageConfiguration();
          break;

        case 2:  //*** Affichage des valeurs des potentiomètres ***
          AffichageParametres();
          break;

        case 3:  //*** Envoi de la valeur minimale de la vitesse (valeur entre 0 et 90)
          if (EntreeCaractere >= 0 && EntreeCaractere < 91)
          {
            VitMini = EntreeCaractere * 10;
            EEPROM.put(EepromVitMin, EntreeCaractere);
            delay(10);
            Serial.print(F("Vitesse Minimale = ")); Serial.print(TemporisationMini); Serial.println(F(" (entre 0 et 1023)"));
          }
          break;

        case 4:  //*** Envoi de la valeur maximale de la vitesse de freinage et d'accélération (valeur entre 1 et 2000)
          if (EntreeCaractere > 0 && EntreeCaractere < 2001)
          {
            AccDeccMaxi = EntreeCaractere;
            EEPROM.put(EepromAccDeccMaxi, AccDeccMaxi);
            Serial.print(F("Borne Pot. Acceleration/Freinage Maxi = ")); Serial.print(AccDeccMaxi); Serial.println(F(" millisecondes"));
          }
          break;

        case 5:  //*** Envoi de la valeur minimale de la Temporisation (valeur supérieure à PasDefaut)
          if (EntreeCaractere > PasDefaut && EntreeCaractere < TemporisationMaxi)
          {
            TemporisationMini = EntreeCaractere;
            EEPROM.put(EepromTemporisationMini, TemporisationMini);
            Serial.print(F("Borne Pot. Tempo. Mini = ")); Serial.print(TemporisationMini); Serial.println(F(" secondes"));
          }
          break;

        case 6:  //*** Envoi de la valeur maximale de la Temporisation (valeur supérieure à 10 et supérieur à la valeur minimale)
          if (EntreeCaractere > TemporisationMini)
          {
            TemporisationMaxi = EntreeCaractere;
            EEPROM.put(EepromTemporisationMaxi, TemporisationMaxi);
            Serial.print(F("Borne Pot. Tempo. Maxi = ")); Serial.print(TemporisationMaxi); Serial.println(F(" secondes"));
          }
          break;
      }
    }
    //*** Remise à zéro des variables ***
    EntreeCaractere = 0;
    SelectionChar = 0;
    NbreCaractere = 0;
    ValideConsigne = false;
  }
}


//*** Réception des données sur les ports Série ***
void serialEvent()
{
  while (Serial.available())
  {
    inChar = (char)Serial.read();
    ScanPortSeries();
  }
}
